#include "spawn.h"

#include "..\algorithms.h"

#include "..\dllcore.cpp"
#include "..\datatypes.cpp"
#include "..\algorithms.cpp"
#include "..\player.cpp"
#include "..\commtypes.cpp"

#include <fstream>
using namespace std;

Sint32 botInfo::coordNumeric(Sint32 y)
{
	return (y * 20 / TILE_MAX_Y) + 1;
}

char botInfo::coordAlpha(Sint32 x)
{
	return 'A' + char(x * 20 / TILE_MAX_X);
}

String botInfo::getCoords(Sint32 x, Sint32 y)
{
	x >>= 4;
	y >>= 4;

	String s;

	char alpha[2];
	alpha[0] = coordAlpha(x);
	alpha[1] = '\0';

	s += alpha;
	s += coordNumeric(y);

	return s;
}

bool botInfo::boolVal(char *msg)
{
	char c = tolower(msg[0]);

	if (c == 'o')
	{
		if (msg[1] && tolower(msg[1]) == 'n')
			return true;

		return false;
	}

	if (c == '1' || c == 'y' || c == 't')
		return true;

	return false;
}

Uint32 botInfo::strFirstInstanceOf(char *msg, char *msg2)
{
	Uint32 len1 = STRLEN(msg), len2 = STRLEN(msg2);

	if (len1 < len2)
		return -1;

	for (Uint32 i = 0; i <= (len1 - len2); i++)
	{
		if (msg[i] == msg2[0])
		{
			for (Uint32 i2 = 0; i2 <= len2; i2++)
			{
				if (msg2[i2] == 0)
					return i;

				if (msg[i + i2] != msg2[i2])
					break;
			}
		}
	}

	return -1;
}

String botInfo::strReplace(char *msg, char *from, char *to)
{
	String ret;

	Uint32 fromlen = STRLEN(from);

	Uint32 pos;

	while (true)
	{
		pos = strFirstInstanceOf(msg, from);
		if (pos == -1)
		{
			/// Append the tail and go ///

			ret += msg;
			break;
		}

		ret.append(msg, pos);
		ret += to;
		msg += pos + fromlen;
	}

	return ret;
}

BankAccount *botInfo::FindBankAccount(char *Owner)
{
	_listnode <BankAccount> *parse = BankBox.head;
	while (parse)
	{
		if (CMPSTR(parse->item->Owner, Owner))
			return parse->item;

		parse = parse->next;
	}

	return NULL;
}

void botInfo::Credit(Sint32 Credits, char *Owner)
{
	BankAccount *t = FindBankAccount(Owner);

	if (!t)
	{
		t = new BankAccount();
		memcpy(t->Owner, Owner, 20);
		BankBox.append(t);
	}

	if (sgn(Credits) == -1)
	{
		if (t->Credits + Credits > t->Credits)
			t->Credits = (0 - 2147483649);
		else
			t->Credits += Credits;
	}
	else
	{
		if (t->Credits + Credits < t->Credits)
			t->Credits = 2147483648;
		else
			t->Credits += Credits;
	}
}

void botInfo::LoadBankFromDisk()
{
	BankBox.clear();

	char Path[520];
	GetCurrentDirectory(520, Path);
	strcat(Path, "\\credits.ini");

	char buffer[3];
	GetPrivateProfileString("Credits", "CanGoNegative", "false", buffer, 3, Path);
	AllowNegativeCredits = boolVal(buffer);

	ifstream file("MERVBot.bank", ios::binary);

	if (file)
	{
		file.seekg(0, ios::end);

		if (file.tellg() % sizeof(BankAccount))
			return;

		file.seekg(0, ios::beg);

		while (!file.eof())
		{
			BankAccount *t = new BankAccount();
			file.read((char*)t, sizeof(BankAccount));

			BankBox.append(t);
		}
	}
}

void botInfo::SaveBankToDisk()
{
	ofstream file("MERVBot.bank", ios::binary);

	if (file)
	{
		_listnode <BankAccount> *parse = BankBox.head;
		while (parse)
		{
			file.write((char*)parse->item, sizeof(BankAccount));

			parse = parse->next;
		}
	}
}

Uint32 botInfo::getNonSpec()
{
	Uint32 ret = 0;

	_listnode <Player> *parse = playerlist->head;
	while (parse)
	{
		if (parse->item->ship != SHIP_Spectator)
			ret++;

		parse = parse->next;
	}

	return ret;
}

StoreItem *botInfo::FindItem(char *Name)
{
	_listnode <StoreItem> *parse = StoreBox.head;
	while (parse)
	{
		if (parse->item->Name == Name)
			return parse->item;

		parse = parse->next;
	}

	return NULL;
}

Uint32 botInfo::CountTeams()
{
	bool b[MAX_TEAMS];

	_listnode <Player> *parse = playerlist->head;
	while (parse)
	{
		b[parse->item->team] = true;

		parse = parse->next;
	}

	Uint32 ret = 0;
	
	for (Uint32 i = 0; i < MAX_TEAMS; i++)
		if (b[i])
			ret++;
	
	return ret;
}

#define G(name) ZeroMemory(buffer, 192);\
		GetPrivateProfileString(title.msg, name, "", buffer, 192, Path)

#define G2(a) if (isNumeric(buffer))\
			a = getInteger(buffer, 10);\
		else\
			a = 0

void botInfo::LoadCredits()
{
	char Path[520];
	GetCurrentDirectory(520, Path);
	strcat(Path, "\\credits.ini");

	char buffer[192];
	String s, title = "Credits";

	G("SoccerGoalEnemy");
	G2(creSoccerGoalEnemy);

	G("SoccerGoalTeam");
	G2(creSoccerGoalTeam);

	G("FlagVictoryTeam");
	G2(creFlagVictoryTeam);

	G("FlagVictoryEnemy");
	G2(creFlagVictoryEnemy);

	G("Kill");
	G2(creKill);

	G("TeamKill");
	G2(creTeamKill);

	G("Killed");
	G2(creKilled);

	G("TeamKilled");
	G2(creTeamKilled);

	G("AnyPrize");
	for (Sint32 i = -28; i <= 28; i++)
		G2(crePrize[i + 28]);
	
	for (i = -28; i <= 28; i++)
	{
		String t;
		t = "Prize";
		t += i;

		G(t.msg);

		if (buffer[0])
			G2(crePrize[i + 28]);
	}
}

void botInfo::LoadStoreFromDisk()
{
	StoreBox.clear();

	char Path[520];
	GetCurrentDirectory(520, Path);
	strcat(Path, "\\buy.ini");

	char buffer[192];

	for (Uint32 i = 0; i < 256; i++)
	{
		String title = "Item";
		title += i;

		G("Name");
		memset(&buffer[20], 0, 172);

		if (buffer[0])
		{
			StoreItem *t = new StoreItem;
			t->Name = buffer;
			t->Name = t->Name.split(' ');
			
			G("Description");

			t->Description = buffer;
			
			G("Value");
			if (!isNumeric(buffer) && buffer[0])
				goto InvalidEntry;

			t->Value = getInteger(buffer, 10);

			for (Uint32 i2 = 0; i2 < 10; i2++)
			{
				String name = "PrivAction";
				name += i2;

				G(name.msg);
				t->PrivActions[i2] = buffer;
			}

			for (i2 = 0; i2 < 10; i2++)
			{
				String name = "PubAction";
				name += i2;

				G(name.msg);
				t->PubActions[i2] = buffer;
			}

			for (i2 = 0; i2 < 10; i2++)
			{
				String name = "SpecialAction";
				name += i2;

				G(name.msg);

				if (!isNumeric(buffer) && buffer[0])
					goto InvalidEntry;

				t->SpecialActions[i2] = getInteger(buffer, 10);
			}
			
			G("SpecialPoints");
			if (!isNumeric(buffer) && buffer[0])
					goto InvalidEntry;

			t->SpecialPoints = getInteger(buffer, 10);

			StoreBox.append(t);

			continue;
InvalidEntry:
			String s;
			s = "Invalid buy.ini entry: ";
			s += i;

			tell(makeEcho(s.msg));
			delete t;
		}
	}
}

//////// Bot list ////////

_linkedlist <botInfo> botlist;

botInfo *findBot(CALL_HANDLE handle)
{
	_listnode <botInfo> *parse = botlist.head;

	while (parse)
	{
		botInfo *item = parse->item;

		if (item->validate(handle))
			return item;

		parse = parse->next;
	}

	return 0;
}


//////// DLL "import" ////////

void botInfo::tell(BotEvent &event)
{
	if (callback && handle)
	{
		event.handle = handle;
		callback(event);
	}
}

void botInfo::gotEvent(BotEvent &event)
{
	if (CONNECTION_DENIED) return;

	switch (event.code)
	{
//////// Periodic ////////
	case EVENT_Tick:
		{
			for (int i = 0; i < 4; ++i)
				--countdown[i];

			if (!countdown[0])
			{
				SaveBankToDisk();

				countdown[0] = 300;
			}
		}
		break;
//////// Arena ////////
	case EVENT_ArenaEnter:
		{
			arena = (char*)event.p[0];
			me = (Player*)event.p[1];	// if(me) {/*we are in the arena*/}
			bool biller = event.p[2] ? true : false;
		}
		break;
	case EVENT_ArenaSettings:
		{
			settings = (arenaSettings*)event.p[0];
		}
		break;
	case EVENT_ArenaLeave:
		{
			me = 0;
		}
		break;
	case EVENT_ArenaListEntry:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
	case EVENT_ArenaListEnd:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
//////// Flag ////////
	case EVENT_FlagGrab:
		{
			Player *p = (Player*)event.p[0];
			Flag *f = (Flag*)event.p[1];
		}
		break;
	case EVENT_FlagDrop:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_FlagMove:
		{
			Flag *f = (Flag*)event.p[0];
		}
		break;
	case EVENT_FlagVictory:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];

			_listnode <Player> *parse = playerlist->head;
			while (parse)
			{
				if (parse->item->team == team)
					Credit(creFlagVictoryTeam, parse->item->name);
				else
					Credit(creFlagVictoryEnemy, parse->item->name);

				parse = parse->next;
			}
		}
		break;
	case EVENT_FlagReward:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
//////// Timed ////////
	case EVENT_TimedGameOver:
		{
			Player *p[5];
			for (int i = 0; i < 5; i++)
				p[i] = (Player*)event.p[i];
		}
		break;
//////// Soccer ////////
	case EVENT_SoccerGoal:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];

			_listnode <Player> *parse = playerlist->head;
			while (parse)
			{
				if (parse->item->team == team)
					Credit(creSoccerGoalTeam, parse->item->name);
				else
					Credit(creSoccerGoalEnemy, parse->item->name);

				parse = parse->next;
			}
		}
		break;
	case EVENT_BallMove:
		{
			PBall *ball = (PBall*)event.p[0];
		}
		break;
//////// File ////////
	case EVENT_File:
		{
			char *name = (char*)event.p[0];
		}
		break;
//////// Player ////////
	case EVENT_PlayerEntering:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerMove:
		{
			Player *p = (Player*)event.p[0];
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[1];
		}
		break;
	case EVENT_PlayerDeath:
		{
			Player *p = (Player*)event.p[0],
				   *k = (Player*)event.p[1];

			if (k->team != p->team)
			{
				Credit(creKill, k->name);
				Credit(creKilled, p->name);
			}
			else
			{
				Credit(creTeamKill, k->name);
				Credit(creTeamKilled, p->name);
			}
			
		}
		break;
	case EVENT_PlayerScore:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerPrize:
		{
			Player *p = (Player*)event.p[0];
			int prize = (int)event.p[1];

			Credit(crePrize[prize + 28], p->name);
		}
		break;
	case EVENT_PlayerShip:
		{
			Player *p = (Player*)event.p[0];
			int oldship = (int)event.p[1];
			int oldteam = (int)event.p[2];
		}
		break;
	case EVENT_PlayerSpec:
		{
			Player *p = (Player*)event.p[0];			
			int oldteam = (int)event.p[1];
			int oldship = (int)event.p[2];
		}
		break;
	case EVENT_PlayerTeam:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			int oldship = (int)event.p[2];
		}
		break;
	case EVENT_PlayerLeaving:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_SelfShipReset:
		{
		}
		break;
	case EVENT_SelfPrize:
		{
			Uint16 prize = (Uint16)event.p[0];
			Uint16 count = (Uint16)event.p[1];
		}
		break;
	case EVENT_SelfUFO:
		{
		}
		break;
//////// Turret ////////
	case EVENT_CreateTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
	case EVENT_DeleteTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
//////// Chat ////////
	case EVENT_Chat:
		{
			int type  = *(int*)&event.p[0];
			int sound = *(int*)&event.p[1];
			Player *p = (Player*)event.p[2];
			char *msg = (char*)event.p[3];

			switch (type)
			{
			case MSG_Arena:
				break;
			case MSG_PublicMacro:
			case MSG_Public:
			case MSG_Team:
			case MSG_TeamPrivate:
			case MSG_Private:			if (!p) break;
				{
				}
				break;
			case MSG_PlayerWarning:		if (!p) break;
				{
				}
				break;
			case MSG_RemotePrivate:
				{
				}
				break;
			case MSG_ServerError:
				{
				}
				break;
			case MSG_Channel:
				{
				}
				break;
			};
		}
		break;
	case EVENT_LocalCommand:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotCommand(p, c);
		}
		break;
	case EVENT_LocalHelp:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotHelp(p, c);
		}
		break;
	case EVENT_RemoteCommand:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemote(p, c, o);
		}
		break;
	case EVENT_RemoteHelp:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemoteHelp(p, c, o);
		}
		break;
	case EVENT_PositionHook:
		{
		}
		break;
//////// Containment ////////
	case EVENT_Init:
		{
			int major = HIWORD(*(int*)&event.p[0]);
			int minor = LOWORD(*(int*)&event.p[0]);
			callback = (CALL_COMMAND)event.p[1];
			playerlist = (CALL_PLIST)event.p[2];
			flaglist = (CALL_FLIST)event.p[3];
			map = (BYTE*)event.p[3];

			if (major > CORE_MAJOR_VERSION)
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin is out of date."));

				CONNECTION_DENIED = true;

				return;
			}
			else if ((major < CORE_MAJOR_VERSION) || (minor < CORE_MINOR_VERSION))
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin requires the latest version of MERVBot."));

				CONNECTION_DENIED = true;

				return;
			}
			else
				tell(makeEcho("DLL plugin connected."));

			tell(makeEcho("Loading data..."));

			LoadBankFromDisk();
			LoadStoreFromDisk();
			LoadCredits();

			tell(makeEcho("Data loaded"));
		}
		break;
	case EVENT_Term:
		{
			tell(makeEcho("DLL plugin disconnected."));

			SaveBankToDisk();
		}
		break;
	};
}


//////// DLL export ////////

_declspec(dllexport) void __stdcall talk(BotEvent &event)
{
	botInfo *bot;

	bot = findBot(event.handle);

	if (!bot)
	{
		bot = new botInfo(event.handle);
		botlist.append(bot);
	}

	if (bot) bot->gotEvent(event);
}


//////// Chatter ////////

void botInfo::sendPrivate(Player *player, BYTE snd, char *msg)
{
	tell(makeSay(MSG_Private, snd, player->ident, msg));
}

void botInfo::sendPrivate(Player *player, char *msg)
{
	tell(makeSay(MSG_Private, 0, player->ident, msg));
}

void botInfo::sendTeam(char *msg)
{
	tell(makeSay(MSG_Team, 0, 0, msg));
}

void botInfo::sendTeam(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Team, snd, 0, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, 0, team, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, BYTE snd, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, snd, team, msg));
}

void botInfo::sendPublic(char *msg)
{
	tell(makeSay(MSG_Public, 0, 0, msg));
}

void botInfo::sendPublic(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Public, snd, 0, msg));
}

void botInfo::sendPublicMacro(char *msg)
{
	tell(makeSay(MSG_PublicMacro, 0, 0, msg));
}

void botInfo::sendPublicMacro(BYTE snd, char *msg)
{
	tell(makeSay(MSG_PublicMacro, snd, 0, msg));
}

void botInfo::sendChannel(char *msg)
{
	tell(makeSay(MSG_Channel, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *msg)
{
	tell(makeSay(MSG_RemotePrivate, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *name, char *msg)
{
	String s;
	s += ":";
	s += name;
	s += ":";
	s += msg;

	sendRemotePrivate(s.msg);
}
